#!/usr/bin/python

import picamera
from PIL import Image, ImageDraw, ImageFont
from time import sleep
import grove_d6t
import pigpio
import time
from PIL import Image
import numpy as np

def getcolormap(temp,mintemp=20,maxtemp=40):
  tt = ((temp - mintemp)*255)/(maxtemp-mintemp)
  if temp > 30 :
    return([tt,0,0])
  else:
    return ([tt,tt,tt])

def omron_scan():
 while(1):
  try:
   tpn, tptat = d6t.readData()
   if tpn == None:
          continue
   print(tpn,"PTAT : %.1f" %tptat)
   #time.sleep(1.0)
   return(tpn)
  except IOError:
   print("IOError")

def create_img(tpn):
  w, h = 512, 512
  maxt = np.amax(tpn)
  mint = np.amin(tpn)
  data = np.zeros((h, w, 3), dtype=np.uint8)
  data[0:127 , 0:127] = getcolormap(tpn[0],mint,maxt)
  data[ 0:127,128:255] = getcolormap(tpn[1],mint,maxt)
  data[ 0:127,256:383] = getcolormap(tpn[2],mint,maxt)
  data[ 0:127,384:511] = getcolormap(tpn[3],mint,maxt)

  data[  128:255,0:127 ] = getcolormap(tpn[4],mint,maxt)
  data[ 128:255,128:255] = getcolormap(tpn[5],mint,maxt)
  data[ 128:255,256:383] = getcolormap(tpn[6],mint,maxt)
  data[ 128:255,384:511] = getcolormap(tpn[7],mint,maxt)

  data[ 256:383,0:127  ]   = getcolormap(tpn[8],mint,maxt)
  data[ 256:383,128:255]   = getcolormap(tpn[9],mint,maxt)
  data[ 256:383,256:383]   = getcolormap(tpn[10],mint,maxt)
  data[ 256:383,384:511]   = getcolormap(tpn[11],mint,maxt)

  data[ 384:511,  0:127]   = getcolormap(tpn[12],mint,maxt)
  data[ 384:511,128:255]   = getcolormap(tpn[13],mint,maxt)
  data[ 384:511,256:383]   = getcolormap(tpn[14],mint,maxt)
  data[ 384:511,384:511]   = getcolormap(tpn[15],mint,maxt)
  fnt = ImageFont.truetype("/usr/local/lib/python2.7/dist-packages/matplotlib-2.2.5-py2.7-linux-armv7l.egg/matplotlib/mpl-data/fonts/ttf/DejaVuSerif-BoldItalic.ttf", 16)
  img1 = Image.fromarray(data, 'RGB')
  d = ImageDraw.Draw(img1)
  d.text((10,64),("0: %3.1f"%tpn[0]),font=fnt, fill = (0,255,0))
  d.text((138,64),("1: %3.1f"%tpn[1]),font=fnt, fill = (0,255,0))
  d.text((266,64),("2: %3.1f"%tpn[2]),font=fnt, fill = (0,255,0))
  d.text((394,64),("3: %3.1f"%tpn[3]),font=fnt, fill = (0,255,0))
  
  d.text((10,138),("4: %3.1f"%tpn[4]),font=fnt, fill = (0,255,0))
  d.text((138,138),("5:%3.1f"%tpn[5]),font=fnt, fill = (0,255,0))
  d.text((266,138),("6: %3.1f"%tpn[6]),font=fnt, fill = (0,255,0))
  d.text((394,138),("7: %3.1f"%tpn[7]),font=fnt, fill = (0,255,0))
  
  d.text((10,266),("8: %3.1f"%tpn[8]),font=fnt, fill = (0,255,0))
  d.text((138,266),("9: %3.1f"%tpn[9]),font=fnt, fill = (0,255,0))
  d.text((266,266),("10: %3.1f"%tpn[10]),font=fnt, fill = (0,255,0))
  d.text((394,266),("11: %3.1f"%tpn[11]),font=fnt, fill = (0,255,0))
  
  d.text((10,394),("12: %3.1f"%tpn[12]),font=fnt, fill = (0,255,0))
  d.text((138,394),("13: %3.1f"%tpn[13]),font=fnt, fill = (0,255,0))
  d.text((266,394),("14: %3.1f"%tpn[14]),font=fnt, fill = (0,255,0))
  d.text((394,394),("15: %3.1f"%tpn[15]),font=fnt, fill = (0,255,0))
  img1.save('overlay.png')
  return(img1)

d6t = grove_d6t.GroveD6t()
camera = picamera.PiCamera()
camera.resolution = (800, 600)
camera.framerate = 24
camera.start_preview()
tpn = omron_scan()

img = create_img(tpn)
pad = Image.new('RGB', (((img.size[0] + 31) // 32) * 32,((img.size[1] + 15) // 16) * 16,    ))
pad.paste(img, (0, 0))
o = camera.add_overlay(pad.tobytes(), size=img.size)
o.alpha = 128
o.layer = 3

while True:
   pad.close();
   tpn = omron_scan()
   img = create_img(tpn)
   camera.remove_overlay(o)
   pad = Image.new('RGB', (    ((img.size[0] + 31) // 32) * 32,    ((img.size[1] + 15) // 16) * 16,))
   pad.paste(img, (0, 0))
   o = camera.add_overlay(pad.tobytes(), size=img.size, alpha=128 , layer=3)
   sleep(1)